from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util

__name_att__ = None;

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('WSPasswordEncryption')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereWSPasswordEncryption");
  exportedObject.put("roleName", "WebSphereWSPasswordEncryption");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.wspasswordencryption.name", objid, "name","WSPasswordEncryption");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.wspasswordencryption.classname", objid, "className","WSPasswordEncryption");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('WSPasswordEncryption');
  return result;



def create(parentid, jsonobject):
  Util.pushPathElement('WSPasswordEncryption')
  if not jsonobject.has("roleProperties"):
    raise Exception("WSPasswordEncryption resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "name", roleProperties.optString("websphere.wspasswordencryption.name", None));
  Util.addIfNotNone(properties, "className", roleProperties.optString("websphere.wspasswordencryption.classname", None));
  print "Creating WSPasswordEncryption with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("WSPasswordEncryption", parentid, properties);
  Util.popPathElement('WSPasswordEncryption');

def update(objid,jsonobject):
  Util.pushPathElement('WSPasswordEncryption')
  if not jsonobject.has("roleProperties"):
    raise Exception("WSPasswordEncryption resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.wspasswordencryption.name", None), "name","WSPasswordEncryption");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.wspasswordencryption.classname", None), "className","WSPasswordEncryption");
  if len(atts) != 0:
    print "Modifying WSPasswordEncryption with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "WSPasswordEncryption configuration up to date.";

  Util.popPathElement('WSPasswordEncryption');
